# Controlify 1.3 (Beta 2) for 1.20

## Additions

### Controller Carousel Screen

This screen appears where the YACL config once was, after opening controller settings. You
can select a controller from the carousel to either edit its settings or set it as the active
controller.

On each entry of the carousel, you can now also see a pixel art icon of the specific controller type,
thanks to [Andrew Grant](https://github.com/Andrew6rant) for making these!

### New Controller Settings Screen

Upon opening an individual controller config, a more refined YACL config screen will appear.
Three categories are available: Basic, Advanced and Controls. Basic contains the most common
settings you will change, advanced holds settings such as gyro and rumble.

With the new settings screen, comes the features of YetAnotherConfigLib v3. Some option descriptions
are now enhanced with gifs and images to better explain what they do. Because the controls groups are now
actually classes as groups, searching the group name will show all controls in that group.

### Greatly improved gyro support

I got my hands on a controller with gyro, so I was able to test and refine the functionality to make
it as intuitive as possible. For starts, it actually works now (I forgot to enable the sensor) and the flick
stick is now a smooth animation rather than just jumping 90 degrees.

### Better controller name detection

If not provided by explicit controller detection, Controlify now uses the name found in the
SDL game controller database, so more controllers should have more accurate names.

### Experimental anti-snapback

Every spring isn't perfect, and can sometimes cause the stick to overshoot the neutral position
when returning to it. This can cause the camera to drift slightly. This feature attempts to mitigate
that. This feature can already be found in DS4Windows, but a more native solution is always better.

To try it out, you need to set a JVM flag in your launcher: `-Dcontrolify.debug.use_snapback=true`, 
however, do be warned, this is extremely buggy and can cause the stick to jitter.

## Bug Fixes

- Fixed the natives onboarding screen getting stuck until a restart
- Fix crash when attempting to load joysticks.
